import "CoreLibs/easing"
import "CoreLibs/object"
import "CoreLibs/sprites"
import "CoreLibs/timer"
import "CoreLibs/ui"

-- Libraries
import 'libraries/noble/Noble'
import "libraries/AnimatedSprite"
import "libraries/pdParticles"
import "libraries/playout"

import 'utilities/enum'
import 'utilities/ui'

ZIndex = {
    player = 4,
    enemy = 3,
    props = 3,
    fx = 6,
    ui = 10,
    alert = 12,
    ground = 100,
    flash = 101
}
CollideGroups = {
    player = 1,
    enemy = 2,
    props = 3,
    items = 4,
    wall = 5
}

import "scripts/player"
import "scripts/bigBoomSprite"
import "scripts/groundSprite"
import "scripts/balebaSprite"
import "scripts/dangerSprite"
import "scripts/tankSprite"

import "scenes/BaseScene"
import 'scenes/Menu'
import 'scenes/Game'

Noble.Settings.setup({
    difficulty = "Medium",
    music = true
})

-- Noble.GameData.setup({
-- 	score = 0
-- })

playdate.display.setRefreshRate(50)

Noble.showFPS = true

Noble.new(Game)
